//
//  ZahlenratespielAppDelegate.m
//  Zahlenratespiel
//
//  Created by Holger Hinzberg
//  http://www.cocoa-coding.de/kids 

#import "ZahlenratespielAppDelegate.h"

@implementation ZahlenratespielAppDelegate
@synthesize rateButton;

@synthesize window;
@synthesize textWertSchieberegler;
@synthesize textRateResultat;
@synthesize textVersuchZaehler;
@synthesize textEingabe;
@synthesize textSpielzeit;
@synthesize schieberegler;
@synthesize schiebereglerZeit;
@synthesize fortschrittsbalken;

- (void)awakeFromNib
{ 
    [textWertSchieberegler setIntValue:50];
    [textVersuchZaehler setStringValue:@""];
    [textSpielzeit setStringValue:@"60"];
    [textRateResultat setStringValue:@""];
    [rateButton setEnabled:NO];
}

- (IBAction)schiebereglerZeitVerschieben:(id)sender
{
    // Wert von Schieberegler holen.
    int sliderwert = [schiebereglerZeit intValue];
    // Wert in das Textfeld schreiben.
    [textSpielzeit setIntValue:sliderwert];
}

- (IBAction)schiebereglerVerschieben:(id)sender
{
    // Wert von Schieberegler holen.
    int sliderwert = [schieberegler intValue];
    // Wert in das Textfeld schreiben.
    [textWertSchieberegler setIntValue:sliderwert];
}

- (IBAction)buttonStartKlick:(id)sender 
{
    int sliderwert = [schieberegler doubleValue];
    int sekundenWert = [schiebereglerZeit intValue];
    
    // Zufallszahl ermitteln.
    
    srandom((uint)time(NULL));
    
    zufallszahl = (int) (random() % sliderwert) + 1; 
    rateversuche = 0;
    
    // Ausgabe, erste Textfeld
    [textRateResultat setStringValue:
     @"Neues Spiel - Neues Glück"];
    
    // Ausgabe, zweites Textfeld
    [textVersuchZaehler setStringValue:
     @"Es kann losgehen"]; 
    
    // Leeren des Eingabefeldes.
    [textEingabe setStringValue:@""];
    
    // [textEingabe setIntValue:zufallszahl];
    [rateButton setEnabled:YES];
    
    sekundenZaehler = sekundenWert;
    
    [meinTimer invalidate];
    meinTimer = 
    [NSTimer scheduledTimerWithTimeInterval:1
                                     target:self
                                   selector:@selector(ticktack:)
                                   userInfo:nil 
                                    repeats:YES];
}


- (void)ticktack:(NSTimer *)aTimer
{
    sekundenZaehler--;
    [fortschrittsbalken 
     setDoubleValue:sekundenZaehler];
    
    if(sekundenZaehler == 0)
    {
        [meinTimer invalidate];
        NSRunAlertPanel(@"Spiel verloren",
                        @"Die Zeit ist abgelaufen.",
                        @"OK", nil, nil);
    }
}


- (IBAction)buttonRatenKlick:(id)sender 
{
    // Anzeige der Rateversuche
    [self ausgabeRateversuche];
    
    // Die Eingabe holen
    int eingabewert = [textEingabe intValue];
    
    // Vergleichen von Eingabe und Zufallszahl.
    if(eingabewert < zufallszahl)
    {
        [textRateResultat setStringValue:
         @"Die gesuchte Zahl ist größer"];
    }
    else if (eingabewert > zufallszahl)
    {
        [textRateResultat setStringValue:
         @"Die gesuchte Zahl ist kleiner"];
    }
    else
    {
        // Spiel gewonnen. Timer anhalten!
        [meinTimer invalidate];
        
        [textRateResultat setStringValue:
         @"Bravo! Das war richtig"];
    }
}

- (void)ausgabeRateversuche
{
    // Ein weiterer Versuch.
    rateversuche++;
    
    // Die Anzahl der Versuche ausgeben.    
    NSString *versuche;
    if(rateversuche == 1)
    {
        versuche = @"Das war der erste Versuch";
    }
    else
    {
        versuche =
        [NSString stringWithFormat:
         @"Das waren %i Versuche",rateversuche];
    }
}


@end




